/*
 * Copyright (c) 2026 University of Insubria <https://www.uninsubria.it>
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or (at
 * your option) any later version. All we ask is that proper credit is given
 * for our work, which includes - but is not limited to - adding the above
 * copyright notice to the beginning of your source code files, and to any
 * copyright notice that you may distribute with programs based on this work.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.
 * <https://fsf.org/>
 */

package qsardes.descriptor;

import java.util.Arrays;
import java.util.HashMap;
import qsardes.molecule.Molecule;
import qsardes.molecule.AbstractMoleculeBuilder;
import java.util.List;
import java.util.Map;

/**
 * Hydrogen bond donors count descriptors abstract class.
 *
 * @author Nicola Chirico
 */
public abstract class DescriptorHBondDonorsCount implements Descriptor
{
    protected DescriptorHBondDonorsCount()
    {
    }

    @Override
    public String toString()
    {
        return "Hydrogen bond donors count";
    }

    @Override
    public DescriptorType get_descriptor_type()
    {
        return DescriptorType.valueOf("DESCRIPTOR");
    }

    @Override
    public List<String> get_descriptor_names()
    {
        return Arrays.asList("nHBDon", "nHBDon_Lipinski");
    }

    @Override
    public Map<String, String> get_descriptor_values(
            AbstractMoleculeBuilder mol_build)
    {
        prepare_descr_map();

        try {
            mol = new Molecule(mol_build);
            calculate_descr();
        } catch (Exception ex) {
            System.err.println(ex);
        }

        return descr_map;
    }

    private void prepare_descr_map()
    {
        final String NAN = String.valueOf(Double.NaN);

        get_descriptor_names().forEach(item -> descr_map.put(item, NAN));
    }

    private void calculate_descr()
    {
        var iac = mol.get_atom_container();

        int donor_count = 0;
        int lipin_count = 0;

        for (var atom : iac.atoms()) {
            if (atom.getSymbol().equals("N") || atom.getSymbol().equals("O")) {
                Integer impl_h_count = atom.getImplicitHydrogenCount();

                lipin_count += impl_h_count;

                if ((atom.getFormalCharge() >= 0) && (impl_h_count > 0)) {
                    donor_count++;
                }
            }
        }

        descr_map.put("nHBDon", String.valueOf(donor_count));
        descr_map.put("nHBDon_Lipinski", String.valueOf(lipin_count));
    }

    private final Map<String, String> descr_map = new HashMap<>();

    private Molecule mol;
}
